Revit,如何在选定的墙上获得位置,长度和高度

时间:2011-07-12 14:02:29

标签: c# parameters get project revit

我有这段代码,我不知道如何显示所选墙的位置,高度和长度:

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using Autodesk.Revit.DB;
using Autodesk.Revit.DB.Architecture;
using Autodesk.Revit.UI;
using Autodesk.Revit.UI.Selection;
using Autodesk.Revit.ApplicationServices;
using Autodesk.Revit.Attributes;
namespace PickSelectionFiltered
{
    [TransactionAttribute(TransactionMode.Manual)]
    [RegenerationAttribute(RegenerationOption.Manual)] 

    public class Class1: IExternalCommand
    {
        public class MySelectionFilter : ISelectionFilter
        {
            Document m_doc = null;

            public bool AllowElement(Element element)
            {
                return element is Wall;
            }
            public bool AllowReference(Reference refer, XYZ point)
            {
                GeometryObject geoObject = 
                m_doc.GetElement(refer)
                     .GetGeometryObjectFromReference(refer);
                return geoObject != null && geoObject is Face;
            }
        }


        public Result Execute(ExternalCommandData commandData, 
          ref string message, ElementSet elements)
        {
            //Get application and document objects
            UIDocument uidoc = commandData.Application.ActiveUIDocument;

            try
            {
                while (true)
                {
                    Reference selRef = 
                      uidoc.Selection.PickObject(ObjectType.Element, 
                        new MySelectionFilter(), "select a room");
                    /*
                     * Add the code to get position, lenght and height
                     * */
                }

            } catch (Autodesk.Revit.Exceptions.OperationCanceledException) { }

            return Result.Succeeded;
        }
    }
}

1 个答案:

答案 0 :(得分:4)

墙的位置是基于它的驱动曲线,从墙上获得的位置曲线:

Wall wall = document.GetReference(setRef) as Wall;
if (wall != null)
{
    LocationCurve locationCurve = wall.Location as LocationCurve;
    XYZ endPoint0 = locationCurve.Curve.get_EndPoint[0];
    XYZ endPoint1 = locationCurve.Curve.get_EndPoint[1];
} 

墙的长度是从墙的参数中获得的:

BuiltInParameter.CURVE_ELEM_LENGTH

墙的宽度是从墙类型的参数中获得的:

BuiltInParameter.WALL_ATTR_WIDTH_PARAM

这适用于标准墙,不适用于幕墙和堆砌墙等特殊墙类型。